     
  % Linear regression cost function
  %   function J = costFunc(X, theta, actual)
  %
  %      m = length(X);
  %      predictions = X .* theta;                   % predictions of hypothesis on all examples
  %      sqrErrors = (predictions .- actual) .^ 2; % squared errors
  %
  %      J = 1/(2*m) * sum(sqrErrors);

  % Logistical regression cost function
  function J = costFunc(H, Y)
    mNegInv = -1 * (1 / length(H));
    
    cost = sum( (Y .* log(H)) + ((1 - Y) .* log(1 - H)) );
    J = mNegInv * cost;
  end

